/*
和风Web Api天气助手
https://console.qweather.com/#/apps

[Script]

[MITM]

*/

const scriptName = `和风天气助手`;
const magicJS = MagicJS(scriptName, "INFO");


let gPublickId = 'HE2409090944241331';
let gPrivateKey = '5721b16806c048f785a4c9e8c66e45f5';
let gApiHost = 'devapi.qweather.com';
let gApiBaseUrl = 'https://devapi.qweather.com'; //api.qweather.com
let gGeoApiHost = 'geoapi.qweather.com';
let gGeoApiBaseUrl = 'https://geoapi.qweather.com'; //geo.qweather.com

let gRetBody;

async function Main() {
    if (magicJS.isStrictRequest) {
        magicJS.checkRecordRequestBody();
    }
    if (magicJS.isRequest) {
        checkHandleRequest();
    } else {
        updateHeaders();
        await tryCheckWeather();
    }
    magicJS.notification.msg('');
    if (gRetBody) {
        magicJS.done({
            body: JSON.stringify(gRetBody)
        });
    } else {
        magicJS.done();
    }
}

function checkHandleRequest() {

}

function updateHeaders() {

}

function getSignature(params, privateKey = gPrivateKey) {
    let keys = [];
    if (params.publicid == void 0) {
        params.publicid = gPublickId;
    }
    if (params.t == void 0) {
        params.t = Date.now();
    }
    for (let k in params) {
        if (k !== 'key' && k !== 'sign' && !/^\s+$/.test(k) && !/^\s+$/.test(params[k])) {
            keys.push(k);
        }
    }

    keys.sort();

    let str = '';
    for (let i in keys) {
        let k = keys[i];
        if (!/\s+/.test(params[k])) {
            str += k + '=' + params[k] + '&';
        }
    }
    str = str.substr(0, str.length - 1) + privateKey;
    const md5 = createWMd5();
    const sign = md5.hex_md5_32(str);
    return sign;
}


async function tryCheckWeather() {
    let ipLocationRet = await getIpLocation();
    let ip;
    let longitude;
    let latitude;
    let cityStr = ``;
    if (ipLocationRet && ipLocationRet.code == 0) {
        let data = ipLocationRet.data;
        for (let k in data) {
            ip = k;
            longitude = data[k].longitude;
            latitude = data[k].latitude;
            cityStr = `${data[k].nation}${data[k].province}${data[k].city}`;
            break;
        }
    }
    let location = `${longitude},${latitude}`;
    let cityDataRet = await cityLookup(location, '');
    let locationId;
    if (cityDataRet && cityDataRet.code == 200) {
        let localDeatail = cityDataRet.location[0]; // 获取到城市信息后，再获取实时的天气和
        locationId = localDeatail.id;
        cityStr = `${localDeatail.country}${localDeatail.adm1}${localDeatail.adm2}${localDeatail.name}`;
    }
    let text = `您当前IP为：${ip}\n`;
    text += `经纬度(经度,纬度)：${longitude},${latitude}\n`;
    text += `所在城市：${cityStr}\n\n`;

    let wDataRet = await getWeatherNow(location);

    let hasRain = false;
    let isWxNotify = false;
    if (wDataRet && wDataRet.code == 200) {
        let now = wDataRet.now;
        // 观测时间
        let obsDate = new Date(now.obsTime);
        text += `当前实时天气(${magicJS.formatDate(obsDate, 'yyyy/MM/dd HH:mm:ss')})：\n`;
        text += `${now.text}\n`;
        text += `过去1小时降水量:${now.precip}毫米\n`;
        text += `温度：${now.temp}℃\n`;
        text += `风速：${now.windSpeed}公里/小时(${now.windScale}级)\n`;
        text += `风向：${now.windDir}(${now.wind360}°)\n`;
        text += `相对湿度：${now.humidity}%\n`;
        text += `能见度：${now.vis}公里\n`;
        text += `气压：${now.pressure}百帕\n`;
        if (now.text.indexOf('阴') > -1) {

        } else if (now.text.indexOf('晴') > -1) {

        } else if (now.text.indexOf('雨') > -1) {
            hasRain = true;
            isWxNotify = true;
        } else if (now.text.indexOf('雪') > -1) {
            hasRain = true;
            isWxNotify = true;
        }
        text += '\n';
    } else {
    }
    let rainDataRet = await getWeatherMinutely(location);
    if (rainDataRet && rainDataRet.code == 200) {
        let updateDate = new Date(rainDataRet.updateTime);
        text += `5分钟级降雨预测(${magicJS.formatDate(updateDate, 'yyyy/MM/dd HH:mm:ss')})：\n`;
        let summary = rainDataRet.summary;
        text += `${summary}\n`;
        let rainList = rainDataRet.minutely;
        text += `最近2小时降水量预测:\n`;
        for (let i in rainList) {
            let timeLine = rainList[i];
            let date = new Date(timeLine.fxTime);
            if (timeLine.precip > 0) {
                hasRain = true;
                isWxNotify = true;
                text += `${magicJS.formatDate(date, 'yyyy/MM/dd HH:mm:ss')}-${timeLine.precip}毫米\n`;
            } else {
                // text += `${magicJS.formatDate(date, 'yyyy/MM/dd HH:mm:ss')}-无\n`;
            }
        }
        text += '\n';
    } else {

    }

    let warningDataRet = await getWeatherWarningNow(location);
    if (warningDataRet && warningDataRet.code == 200) {
        let warningList = warningDataRet.warning;
        if (warningList && warningList.length > 0) {
            for (let i = 0; i < warningList.length; i++) {
                let warning = warningList[i];
                text += `${getSeverityText(warning.severity, warning.severityColor)}预警-${warning.typeName}：\n`;
                text += `${warning.text}\n`;
            }
            hasRain = true;
            isWxNotify = true;
        }
    }
    magicJS.notification.appendNotifyInfo(text);
    if (isWxNotify) {
        let sendRet = await magicJS.fastWxpusherSend(text, `${cityStr}天气预报`);
    }
}


function getSeverityText(severity, color) {
    let colorMap = {
        White: '白色',
        Blue: '蓝色',
        Green: '绿色',
        Yellow: '黄色',
        Orange: '橙色',
        Red: '红色',
        Black: '黑色',
    };
    return `${colorMap[color] || color}`;
}
/**
 * 城市搜索
 * @param {*} location
 * @param {*} adm
 * @returns
 */
async function cityLookup(location, adm = '') {
    let reqData = {
        location: location,
        lang: 'zh-hans',
    };
    reqData.sign = getSignature(reqData, gPrivateKey);
    const url = `${gGeoApiBaseUrl}/v2/city/lookup?${magicJS.objToQueryStr(reqData)}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': gGeoApiHost,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求城市搜索异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

/**
 * 实时天气
 * 返回数据:
 * code 请参考状态码
 * updateTime 当前API的最近更新时间
 * fxLink 当前数据的响应式页面，便于嵌入网站或应用
 * now.obsTime 数据观测时间
 * now.temp 温度，默认单位：摄氏度
 * now.feelsLike 体感温度，默认单位：摄氏度
 * now.icon 天气状况的图标代码，另请参考天气图标项目
 * now.text 天气状况的文字描述，包括阴晴雨雪等天气状态的描述
 * now.wind360 风向360角度
 * now.windDir 风向
 * now.windScale 风力等级
 * now.windSpeed 风速，公里/小时
 * now.humidity 相对湿度，百分比数值
 * now.precip 过去1小时降水量，默认单位：毫米
 * now.pressure 大气压强，默认单位：百帕
 * now.vis 能见度，默认单位：公里
 * now.cloud 云量，百分比数值。可能为空
 * now.dew 露点温度。可能为空
 * refer.sources 原始数据来源，或数据源说明，可能为空
 * refer.license 数据许可或版权声明，可能为空
 * @param {*} location
 * @returns
 */
async function getWeatherNow(location) {
    let reqData = {
        location: location,
        lang: 'zh-hans',
        unit: 'm',
    };
    reqData.sign = getSignature(reqData, gPrivateKey);
    const url = `${gApiBaseUrl}/v7/weather/now?${magicJS.objToQueryStr(reqData)}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': gApiHost,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求实时天气异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

/**
 * 分钟级降水
 * 返回数据:
 * code 请参考状态码
 * updateTime 当前API的最近更新时间
 * fxLink 当前数据的响应式页面，便于嵌入网站或应用
 * summary 分钟降水描述
 * minutely.fxTime 预报时间
 * minutely.precip 5分钟累计降水量，单位毫米
 * minutely.type 降水类型：rain = 雨，snow = 雪
 * refer.sources 原始数据来源，或数据源说明，可能为空
 * refer.license 数据许可或版权声明，可能为空
 *
 * @param {*} location
 * @returns
 */
async function getWeatherMinutely(location) {
    let reqData = {
        location: location,
        // lang: 'zh-hans',
    };
    reqData.sign = getSignature(reqData, gPrivateKey);
    const url = `${gApiBaseUrl}/v7/minutely/5m?${magicJS.objToQueryStr(reqData)}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': gApiHost,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求分钟级降水异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


/**
 * 实时天气
 * 返回数据:
 * code 请参考状态码
 * updateTime 当前API的最近更新时间
 * fxLink 当前数据的响应式页面，便于嵌入网站或应用
 * now.obsTime 数据观测时间
 * now.temp 温度，默认单位：摄氏度
 * now.icon 天气状况的图标代码，另请参考天气图标项目
 * now.text 天气状况的文字描述，包括阴晴雨雪等天气状态的描述
 * now.wind360 风向360角度
 * now.windDir 风向
 * now.windScale 风力等级
 * now.windSpeed 风速，公里/小时
 * now.humidity 相对湿度，百分比数值
 * now.precip 过去1小时降水量，默认单位：毫米
 * now.pressure 大气压强，默认单位：百帕
 * now.cloud 云量，百分比数值。可能为空
 * now.dew 露点温度。可能为空
 * refer.sources 原始数据来源，或数据源说明，可能为空
 * refer.license 数据许可或版权声明，可能为空
 * @param {*} location
 * @returns
 */
async function getGridWeather(location) {
    let reqData = {
        location: location,
        lang: 'zh-hans',
        unit: 'm',
    };
    reqData.sign = getSignature(reqData, gPrivateKey);
    const url = `${gApiBaseUrl}/v7/grid-weather/now?${magicJS.objToQueryStr(reqData)}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': gApiHost,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求格点实时天气异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

/**
 * code 请参考状态码
 * updateTime 当前API的最近更新时间
 * fxLink 当前数据的响应式页面，便于嵌入网站或应用
 * warning.id 本条预警的唯一标识，可判断本条预警是否已经存在
 * warning.sender 预警发布单位，可能为空
 * warning.pubTime 预警发布时间
 * warning.title 预警信息标题
 * warning.startTime 预警开始时间，可能为空
 * warning.endTime 预警结束时间，可能为空
 * warning.status 预警信息的发布状态
 * warning.level 预警等级（已弃用），不要再使用这个字段，该字段已弃用，目前返回为空或未更新的值。请使用severity和severityColor代替
 * warning.severity 预警严重等级
 * warning.severityColor 预警严重等级颜色，可能为空
 * warning.type 预警类型ID
 * warning.typeName 预警类型名称
 * warning.urgency 预警信息的紧迫程度，可能为空
 * warning.certainty 预警信息的确定性，可能为空
 * warning.text 预警详细文字描述
 * warning.related 与本条预警相关联的预警ID，当预警状态为cancel或update时返回。可能为空
 * refer.sources 原始数据来源，或数据源说明，可能为空
 * refer.license 数据许可或版权声明，可能为空
 * @param {*} location
 * @returns
 */
async function getWeatherWarningNow(location) {
    let reqData = {
        location: location,
    };
    reqData.sign = getSignature(reqData, gPrivateKey);
    const url = `${gApiBaseUrl}/v7/warning/now?${magicJS.objToQueryStr(reqData)}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': gApiHost,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求天气灾害预警异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}
/**
 * 国内服务
 * 示例结果：
 * {
        "reqid": "ad9f530bc5e40e60a25073dfd72016c6",
        "code": 0,
        "data": {
            "14.145.199.18": {
                "area_code": "86",
                "city": "广州市",
                "city_id": 160063402,
                "continent": "亚洲",
                "continent_code": "AP",
                "country_id": 100000,
                "isp": "电信",
                "latitude": 23.162472,
                "longitude": 113.373663,
                "nation": "中国",
                "nation_code": "CN",
                "province": "广东",
                "province_id": 440000,
                "subdivision_1_iso_code": "*",
                "subdivision_1_name": "广东",
                "subdivision_2_iso_code": "*",
                "subdivision_2_name": "广州市",
                "time_zone": "UTC+8"
            }
        }
    }
 * @param {*} ip 可选
 */
async function getIpLocation(ip = '') {
    let url = `https://webapi-pc.meitu.com/common/ip_location?ip=${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `webapi-pc.meitu.com`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


/**
 * 国内服务
 * 示例结果：
 * {
        "code": 200,
        "data": {
            "ip": "14.145.199.18",
            "continent": "亚洲",
            "country_english": "",
            "country": "中国",
            "prov": "广东",
            "city": "广州",
            "district": "",
            "isp": "电信",
            "lat": "23.125178",
            "lng": "113.280637",
            "area_code": "440100",
            "city_code": "020",
            "elevation": "18",
            "time_zone": "Asia/Shanghai",
            "weather_station": "CHXX0037",
            "zip_code": "510000"
        },
        "msg": "success",
        "ip": "14.145.199.18",
        "time": "2024-09-09 14:45:11",
        "source": "青桔API：api.qjqq.cn"
    }
 * @param {*} ip 可选
 */
async function getIpLocation1(ip = '') {
    let url = `https://api.qjqq.cn/api/Local`;
    if (ip && ip.length > 0) {
        url = `https://api.qjqq.cn/api/district?ip=${ip}`;
    }
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `api.qjqq.cn`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

/**
 * 国外服务
 * 示例结果：
 * {
        "organization": "Akamai Connected Cloud",
        "longitude": 72.8856,
        "city": "Mumbai",
        "timezone": "Asia/Kolkata",
        "isp": "Akamai Connected Cloud",
        "offset": 19800,
        "region": "Maharashtra",
        "asn": 63949,
        "asn_organization": "Akamai Connected Cloud",
        "country": "India",
        "ip": "2400:8904::f03c:94ff:fed7:7a34",
        "latitude": 19.0748,
        "postal_code": "400017",
        "continent_code": "AS",
        "country_code": "IN",
        "region_code": "MH"
    }
 * @param {*} ip 可选
 * @returns
 */
async function getIpLocation2(ip = '') {
    let url = `https://api.ip.sb/geoip/${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `api.ip.sb`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

/**
 * 国外服务
 * 示例结果：
    {
        "ip": "14.145.199.18",
        "country_code": "CN",
        "country_name": "China",
        "region_name": "Guangdong",
        "city_name": "Guangzhou",
        "latitude": 23.12736,
        "longitude": 113.26457,
        "zip_code": "510140",
        "time_zone": "+08:00",
        "asn": "4134",
        "as": "Asia Pacific Network Information Centre",
        "is_proxy": false,
        "message": "Limit to 500 queries per day. Sign up for a Free plan at https://www.ip2location.io to get 30K queries per month."
    }
 * @param {*} ip 必选参数
 * @returns
 */
async function getIpLocation3(ip) {
    let url = `https://api.ip2location.io/?ip=${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `api.ip2location.io`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


/**
 * 国外服务
 * 示例结果：
    {
        "ip": "14.145.199.18",
        "city": "Guangzhou",
        "province": "Guangdong",
        "country": "China",
        "continent": "Asia",
        "isp": "Chinanet",
        "time_zone": "Asia/Shanghai",
        "latitude": 23.1181,
        "longitude": 113.2539,
        "postal_code": null,
        "iso_code": "CN",
        "network": "14.145.192.0/19",
        "notice": "api文档在/docs路径下，调用并发数是有限制的 ©2021-09-27->now",
        "provider": "Powered by Bboysoul",
        "blog": "https://www.bboy.app",
        "tg_group": "https://t.me/bboyapp",
        "data_updatetime": 20240829,
        "count": 20269557
    }
 * @param {*} ip 必选参数
 * @returns
 */
async function getIpLocation4(ip) {
    let url = `https://realip.cc/?ip=${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `realip.cc`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


/**
 * 国外服务
 * 示例结果：
    {
        "status": "success",
        "continent": "亚洲",
        "continentCode": "AS",
        "country": "印度",
        "countryCode": "IN",
        "region": "MH",
        "regionName": "马哈拉施特拉邦",
        "city": "孟买",
        "district": "",
        "zip": "400017",
        "lat": 19.0748,
        "lon": 72.8856,
        "timezone": "Asia/Kolkata",
        "offset": 19800,
        "currency": "INR",
        "isp": "Akamai Technologies, Inc.",
        "org": "Linode",
        "as": "AS63949 Akamai Connected Cloud",
        "asname": "AKAMAI-LINODE-AP",
        "mobile": false,
        "proxy": false,
        "hosting": true,
        "query": "45.79.120.221"
    }
 * @param {*} ip 可选
 * @returns
 */
async function getIpLocation5(ip = '') {
    let url = `http://demo.ip-api.com/json/${ip}?fields=66842623&lang=zh-CN`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `demo.ip-api.com`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

/**
 * 国外服务
 * 示例结果：
    {
        "ip": "14.145.199.18",
        "rir": "APNIC",
        "is_bogon": false,
        "is_mobile": false,
        "is_crawler": false,
        "is_datacenter": false,
        "is_tor": false,
        "is_proxy": false,
        "is_vpn": false,
        "is_abuser": false,
        "company": {
            "name": "CHINANET Guangdong province network",
            "abuser_score": "0.0006 (Low)",
            "domain": "chinatelecom.cn",
            "type": "isp",
            "network": "14.144.0.0 - 14.159.255.255",
            "whois": "https://api.ipapi.is/?whois=14.144.0.0"
        },
        "abuse": {
            "name": "IPMASTER CHINANET-GD",
            "address": "NO.18,RO. ZHONGSHANER,YUEXIU DISTRIC,GUANGZHOU",
            "email": "anti-spam@chinatelecom.cn",
            "phone": "+86-20-87189274"
        },
        "asn": {
            "asn": 4134,
            "abuser_score": "0.0006 (Low)",
            "route": "14.144.0.0/12",
            "descr": "CHINANET-BACKBONE No.31,Jin-rong Street, CN",
            "country": "cn",
            "active": true,
            "org": "CHINANET BACKBONE",
            "domain": "chinatelecom.cn",
            "abuse": "anti-spam@chinatelecom.cn",
            "type": "business",
            "updated": "2021-06-15",
            "rir": "APNIC",
            "whois": "https://api.ipapi.is/?whois=AS4134"
        },
        "location": {
            "continent": "AS",
            "country": "China",
            "country_code": "CN",
            "state": "Guangdong",
            "city": "Guangzhou",
            "latitude": 23.11667,
            "longitude": 113.25,
            "zip": "510800",
            "timezone": "Asia/Shanghai",
            "local_time": "2024-09-09T14:38:21+08:00",
            "local_time_unix": 1725863901,
            "is_dst": false
        },
        "elapsed_ms": 1.48
    }
 * @param {*} ip 可选
 * @returns
 */
async function getIpLocation6(ip = '') {
    let url = `https://api.ipapi.is/?ip=${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `api.ipapi.is`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


/**
 * 国外服务
 * 示例结果：
    {
        "organization": "Akamai Connected Cloud",
        "longitude": 72.8856,
        "city": "Mumbai",
        "timezone": "Asia/Kolkata",
        "isp": "Akamai Connected Cloud",
        "offset": 19800,
        "region": "Maharashtra",
        "asn": 63949,
        "asn_organization": "Akamai Connected Cloud",
        "country": "India",
        "ip": "2400:8904::f03c:94ff:fed7:7a34",
        "latitude": 19.0748,
        "postal_code": "400017",
        "continent_code": "AS",
        "country_code": "IN",
        "region_code": "MH"
    }
 * @param {*} ip 可选
 * @returns
 */
async function getIpLocation7(ip = '') {
    let url = `https://api.ip.sb/geoip/${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `api.ip.sb`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


async function getIpLocation9(ip) {
    let url = `https://ipapi.com/ip_api.php?ip=${ip}`;
    let headers = {
        'Accept': `*/*`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Connection': `keep-alive`,
        'Cookie': ``,
        'Host': `ipapi.com`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 16_6_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.6 Mobile/15E148 Safari/604.1`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求数据异常\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

Main().catch((e) => magicJS.logger.log(`-\n ${e}`)).finally(() => magicJS.done());

//---SyncByPyScript---MagicJS3-start
function MagicJS(e = "MagicJS", t = "INFO") { const n = () => { const e = "undefined" != typeof $loon, t = "undefined" != typeof $task, r = "undefined" != typeof module, n = "undefined" != typeof $httpClient && !e, o = "undefined" != typeof $storm, i = "undefined" != typeof $environment && void 0 !== $environment["stash-build"]; var s = n || e || o || i; const a = "undefined" != typeof importModule; return { isLoon: e, isQuanX: t, isNode: r, isSurge: n, isStorm: o, isStash: i, isSurgeLike: s, isScriptable: a, get name() { return e ? "Loon" : t ? "QuantumultX" : r ? "NodeJS" : n ? "Surge" : a ? "Scriptable" : "unknown" }, get build() { return n ? $environment["surge-build"] : i ? $environment["stash-build"] : o ? $storm.buildVersion : void 0 }, get language() { if (n || i) return $environment.language }, get version() { return n ? $environment["surge-version"] : i ? $environment["stash-version"] : o ? $storm.appVersion : r ? process.version : void 0 }, get system() { return n ? $environment.system : r ? process.platform : void 0 }, get systemVersion() { if (o) return $storm.systemVersion }, get deviceName() { if (o) return $storm.deviceName } } }, o = (r, e = "INFO") => { let n = e, t = "\n"; const o = { SNIFFER: 6, DEBUG: 5, INFO: 4, NOTIFY: 3, WARNING: 2, ERROR: 1, CRITICAL: 0, NONE: -1 }, i = { SNIFFER: "", DEBUG: "", INFO: "", NOTIFY: "", WARNING: "❗ ", ERROR: "❌ ", CRITICAL: "❌ ", NONE: "" }, s = (e, t = "INFO") => { o[n] < o[t.toUpperCase()] || console.log(`██[${r}][${t}]` + i[t.toUpperCase()] + e + "\n") }; return { getLevel: () => n, setLevel: e => { n = e }, sniffer: (...e) => { e = e.join(t); s(e, "SNIFFER") }, log: (...e) => { e = e.join(t); console.log(`██[${r}]` + e + "\n") }, debug: (...e) => { e = e.join(t); s(e, "DEBUG") }, info: (...e) => { e = e.join(t); s(e, "INFO") }, notify: (...e) => { e = e.join(t); s(e, "NOTIFY") }, warning: (...e) => { e = e.join(t); s(e, "WARNING") }, error: (...e) => { e = e.join(t); s(e, "ERROR") }, retry: (...e) => { e = e.join(t); s(e, "RETRY") } } }; return new class { constructor(e, t) { var r; this._startTime = Date.now(), this.version = "3.0.0", this.scriptName = e, this.env = n(), this.logger = o(e, t), this.http = "function" == typeof MagicHttp ? MagicHttp(this.env, this.logger) : void 0, this.data = "function" == typeof MagicData ? MagicData(this.env, this.logger) : void 0, this.notification = "function" == typeof MagicNotification ? MagicNotification(this.scriptName, this.env, this.logger, this.http) : void 0, this.utils = "function" == typeof MagicUtils ? MagicUtils(this.env, this.logger) : void 0, this.qinglong = "function" == typeof MagicQingLong ? MagicQingLong(this.env, this.data, this.logger) : void 0, void 0 !== this.data && (t = this.data.read("magic_loglevel"), r = this.data.read("magic_bark_url"), t && this.logger.setLevel(t.toUpperCase()), r) && this.notification.setBark(r), this.logger.info(e + ", 开始执行!") } get isRequest() { return "undefined" != typeof $request } get isStrictRequest() { return "undefined" != typeof $request && "undefined" == typeof $response } get isResponse() { return "undefined" != typeof $response } get isDebug() { return "DEBUG" === this.logger.level } get request() { return "undefined" != typeof $request ? $request : void 0 } get response() { if ("undefined" != typeof $response) return $response.hasOwnProperty("status") && ($response.statusCode = $response.status), $response.hasOwnProperty("statusCode") && ($response.status = $response.statusCode), $response } log(...e) { this.logger.log(e) } toStr(e, t = null) { try { return JSON.stringify(e) } catch { return t } } toObj(e, t = null) { try { return JSON.parse(e) } catch { return t } } checkRecordRequestBody() { if (this.isRequest) { var t = $request.body; if (t) { var r = this.env, n = $request.path; let e = this.scriptName + "#" + n.replace("/", "_"); e = e.replace("?", "#"), r.isQuanX && $prefs.setValueForKey(t, e), (r.isLoon || r.isSurge) && $persistentStore.write(t, e), r.isNode && require("fs").writeFileSync(e + ".json", t, { flag: "w" }, e => console.log(e)) } } } getRequestBody() { var e = this.env, t = $request.path; let r = this.scriptName + "#" + t.replace("/", "_"); if (r = r.replace("?", "#"), e.isSurge || e.isLoon) return $persistentStore.read(r); if (e.isQuanX) return $prefs.valueForKey(r); if (e.isNode) { t = r + ".json", e = require("fs"); if (!e.existsSync(t)) return JSON.parse(e.readFileSync(t)) } } getResponseBody() { if ($response) return $response.body } parseCookies(e, t = !1) { let r = {}; return t ? e && e.split(";").forEach(function (e) { e = e.split("="); r[e.shift().trim()] = decodeURIComponent(e.join("=")) }) : e && e.split(";").forEach(function (e) { e = e.split("="); r[e.shift().trim()] = e.join("=") }), r } serializeCookies(e, t = !1) { var r = []; if (t) for (var n in e) { var o = e[n], n = n + "=" + encodeURIComponent(o); r.push(n) } else for (var i in e) { var s = e[i], i = i + "=" + s; r.push(i) } return r.join("; ") } parseSetCookies(e) { var t = e.split(/,\s*/).map(e => { var e = e.trim().split(/;\s*(?=[^=]+=[^;]*)/), t = e[0].split("=").map(e => e.trim()); const r = { name: t[0], value: t[1] }; return e.slice(1).forEach(e => { var [e, t] = e.split("=").map(e => e.trim()); r[e] = t || !0 }), r }), r = []; let n = 0; for (; n < t.length;) { var o, i = t[n]; r.push(i), i.Expires ? ((o = t[n + 1]) && (i.Expires = i.Expires + "," + o.name), n += 2) : n += 1 } return r } objToQueryStr(t, r) { let n = ""; for (const o in t) { let e = t[o]; null != e && "" !== e && ("object" == typeof e ? e = JSON.stringify(e) : r && (e = encodeURIComponent(e)), n += `${o}=${e}&`) } return n = n.substring(0, n.length - 1) } parseQueryStr(e) { var t = {}, r = (e = -1 < e.indexOf("?") ? e.split("?")[1] : e).split("&"); for (let e = 0; e < r.length; e++) { var n = r[e].split("="); t[n[0]] = n[1] } return t } deepClone(e, t) { for (var r in t = t || {}, e) "object" == typeof e[r] ? (t[r] = e[r].constructor === Array ? [] : {}, this.deepClone(e[r], t[r])) : t[r] = e[r]; return t } formatDate(e, t) { var r, n = { "M+": e.getMonth() + 1, "d+": e.getDate(), "H+": e.getHours(), "m+": e.getMinutes(), "s+": e.getSeconds(), "q+": Math.floor((e.getMonth() + 3) / 3), S: e.getMilliseconds() }; for (r in /(y+)/.test(t) && (t = t.replace(RegExp.$1, (e.getFullYear() + "").substr(4 - RegExp.$1.length))), n) new RegExp("(" + r + ")").test(t) && (t = t.replace(RegExp.$1, 1 == RegExp.$1.length ? n[r] : ("00" + n[r]).substr(("" + n[r]).length))); return t } parseDate(a, e) { let l = { y: 0, M: 1, d: 0, H: 0, h: 0, m: 0, s: 0, S: 0 }; (e = e || "yyyy-MM-dd").replace(/([^yMdHmsS]*?)(([yMdHmsS])\3*)([^yMdHmsS]*?)/g, function (e, t, r, n, o, i, s) { return a = a.replace(new RegExp(t + "(\\d{" + r.length + "})" + o), function (e, t) { return l[n] = parseInt(t), "" }), "" }), l.M--; e = new Date(l.y, l.M, l.d, l.H, l.m, l.s); return 0 !== l.S && e.setMilliseconds(l.S), e } getBaseDoneHeaders(e = {}) { return Object.assign({ "Access-Control-Allow-Origin": "*", "Access-Control-Allow-Methods": "POST,GET,OPTIONS,PUT,DELETE", "Access-Control-Allow-Headers": "Origin, X-Requested-With, Content-Type, Accept" }, e) } getHtmlDoneHeaders() { return this.getBaseDoneHeaders({ "Content-Type": "text/html;charset=UTF-8" }) } getJsonDoneHeaders() { return this.getBaseDoneHeaders({ "Content-Type": "text/json; charset=utf-8", Connection: "keep-alive" }) } doWxpusherSend(e) { var t = this.getJsonDoneHeaders(), t = (t.Host = "wxpusher.zjiecode.com", t["Content-Type"] = "application/json;charset=UTF-8", { url: "https://wxpusher.zjiecode.com/api/send/message", headers: t, body: JSON.stringify(e) }); return this.http.post(t) } fastWxpusherSend(e, t = "", r = "") { return this.doWxpusherSend({ appToken: "AT_7wDWqSoT8xpJCQqJtHpshKhw7kXc0XCW", content: e, summary: t, contentType: 1, topicIds: [], uids: ["UID_6P4B00X6Zv8U2oKC0I2R09emxtqq"], url: r, verifyPay: !1, verifyPayType: 0 }) } isEmpty(e) { return void 0 === e || null == e || "" == e || "null" == e || "undefined" == e || 0 === e.length } base64Encode(e) { var t, r, n, o = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"; let i, s, a; for (a = e.length, s = 0, i = ""; s < a;) { if (t = 255 & e.charCodeAt(s++), s == a) { i = (i += o.charAt(t >> 2)) + o.charAt((3 & t) << 4) + "=="; break } if (r = e.charCodeAt(s++), s == a) { i = (i = (i += o.charAt(t >> 2)) + o.charAt((3 & t) << 4 | (240 & r) >> 4)) + o.charAt((15 & r) << 2) + "="; break } n = e.charCodeAt(s++), i = (i = (i = (i += o.charAt(t >> 2)) + o.charAt((3 & t) << 4 | (240 & r) >> 4)) + o.charAt((15 & r) << 2 | (192 & n) >> 6)) + o.charAt(63 & n) } return i } base64Decode(e) { var t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="; if (/([^\s]+[^0-9a-zA-Z\+\/\=]|[^0-9a-zA-Z\+\/\=]\s+)/.test(e)) throw new Error("Invalid base64 input"); var r, n, o, i, s, a, l = e.replace(/\s/g, ""); let u = "", c = 0; for (; c < l.length;)o = t.indexOf(l.charAt(c++)), r = (15 & (i = t.indexOf(l.charAt(c++)))) << 4 | (s = t.indexOf(l.charAt(c++))) >> 2, n = (3 & s) << 6 | (a = t.indexOf(l.charAt(c++))), u += String.fromCharCode(o << 2 | i >> 4), 64 !== s && (u += String.fromCharCode(r)), 64 !== a && (u += String.fromCharCode(n)); return u = this.utf8Decode(u) } utf8Decode(t) { let e = [], r = 0, n = 0, o = 0; for (t = t.replace(/\r\n/g, "\n"); r < t.length;) { n = 255 & t.charCodeAt(r), o = 0, o = n <= 191 ? (n &= 127, 1) : n <= 223 ? (n &= 31, 2) : n <= 239 ? (n &= 15, 3) : (n &= 7, 4); for (let e = 1; e < o; ++e)n = n << 6 | 63 & t.charCodeAt(e + r); 4 === o ? (n -= 65536, e.push(String.fromCharCode(55296 | n >> 10 & 1023)), e.push(String.fromCharCode(56320 | 1023 & n))) : e.push(String.fromCharCode(n)), r += o } return e.join("") } parseJwt(e) { try { var t = e.split("."), r = t[0].replace(/-/g, "+").replace(/_/g, "/"), n = this.base64Decode(r).replace(/\0/g, ""), o = JSON.parse(n), i = t[1].replace(/-/g, "+").replace(/_/g, "/"), s = this.base64Decode(i).replace(/\0/g, ""); return { header: o, payload: JSON.parse(s), signature: t[2] } } catch (e) { return this.log(e), null } } costTime() { var e = this.scriptName + "执行完毕！", t = (this._endTime = (new Date).getTime(), this._endTime - this._startTime); this.logger.info(e + `耗时【${t / 1e3}】秒`) } done = (e = {}) => { this.costTime(), "undefined" != typeof $done && $done(e) } }(e, t) } function MagicHttp(d, p) { var e; let g; d.isNode && (e = require("axios"), g = e.create()); class t { constructor(e = !0) { this.handlers = [], this.isRequest = e } use(e, t, r) { return "function" == typeof e && p.debug("Register fulfilled " + e.name), "function" == typeof t && p.debug("Register rejected " + t.name), this.handlers.push({ fulfilled: e, rejected: t, synchronous: !(!r || "boolean" != typeof r.synchronous) && r.synchronous, runWhen: r ? r.runWhen : null }), this.handlers.length - 1 } eject(e) { this.handlers[e] && (this.handlers[e] = null) } forEach(t) { this.handlers.forEach(e => { null !== e && t(e) }) } } function f(e) { let r = { ...e }; return r.params && !d.isNode && (e = Object.keys(r.params).map(e => { var t = encodeURIComponent(e); return r.url = r.url.replace(new RegExp(e + "=[^&]*", "ig"), ""), r.url = r.url.replace(new RegExp(t + "=[^&]*", "ig"), ""), t + "=" + encodeURIComponent(r.params[e]) }).join("&"), r.url.indexOf("?") < 0 && (r.url += "?"), /(&|\?)$/g.test(r.url) || (r.url += "&"), r.url += e, delete r.params, p.debug("Params to QueryString: " + r.url)), r } const h = (e, t = null) => { if (e) { t = { ...e, config: e.config || t, status: e.statusCode || e.status, body: e.body || e.data, headers: e.headers || e.header }; if ("string" == typeof t.body) try { t.body = JSON.parse(t.body) } catch { } return delete t.data, t } return e }; const y = (e, t = null) => { if (e && 400 <= e.status) return p.debug("Raise exception when status code is " + e.status), { name: "RequestException", message: "Request failed with status code " + e.status, config: t || e.config, response: e } }, m = { request: new t, response: new t(!1) }; let v = [], b = [], S = !0; function N(e) { return e = f(e), p.debug(`HTTP ${e.method.toUpperCase()}:` + "\n" + JSON.stringify(e)), e } function E(t) { try { t = t && h(t), p.sniffer(`HTTP ${t.config.method.toUpperCase()}:` + "\n" + JSON.stringify(t.config) + "\nSTATUS CODE:\n" + t.status + "\nRESPONSE:\n" + ("object" == typeof t.body ? JSON.stringify(t.body) : t.body)); var e = y(t); return e ? Promise.reject(e) : t } catch (e) { return p.error(e), t } } const r = (e, r) => { let n; r = ((e, t) => { let r = "object" == typeof t ? { headers: {}, ...t } : { url: t, headers: {} }; return r.method || (r.method = e), !0 === (r = f(r)).rewrite && (d.isSurge ? (r.headers["X-Surge-Skip-Scripting"] = !1, delete r.rewrite) : d.isQuanX && (r.hints = !1, delete r.rewrite)), d.isSurgeLike ? (t = r.headers["content-type"] || r.headers["Content-Type"], "GET" !== r.method && t && 0 <= t.indexOf("application/json") && r.body instanceof Array && (r.body = JSON.stringify(r.body), p.debug("Convert Array object to String: " + r.body))) : d.isQuanX ? (r.hasOwnProperty("body") && "string" != typeof r.body && (r.body = JSON.stringify(r.body)), r.method = e) : d.isNode && ("POST" === e || "PUT" === e || "PATCH" === e || "DELETE" === e ? r.data = r.data || r.body : "GET" === e && (r.params = r.params || r.body), delete r.body), r })(e.toUpperCase(), r), n = d.isNode ? g : d.isSurgeLike ? i => new Promise((n, o) => { $httpClient[e.toLowerCase()](i, (e, t, r) => { e ? (e = { name: e.name || e, message: e.message || e, stack: e.stack || e, config: i, response: h(t) }, o(e)) : (t.config = i, t.body = r, n(t)) }) }) : n => new Promise((r, t) => { $task.fetch(n).then(e => { e = h(e, n); var t = y(e, n); if (t) return Promise.reject(t); r(e) }).catch(e => { e = { name: e.message || e.error, message: e.message || e.error, stack: e.error, config: n, response: e.response ? h(e.response) : null }; t(e) }) }); let o; var t = r; try { v = [], b = [], m.request.forEach(e => { "function" == typeof e.runWhen && !1 === e.runWhen(t) || (S = S && e.synchronous, v.unshift(e.fulfilled, e.rejected)) }), m.response.forEach(e => { b.push(e.fulfilled, e.rejected) }) } catch (e) { p.error(`Failed to register interceptors: ${e}.`) } var i = [N, void 0], s = [E, void 0]; if (S) { for (p.debug("Interceptors are executed in synchronous mode"), Array.prototype.unshift.apply(v, i), v = v.concat([N, void 0]); v.length;) { var a = v.shift(), l = v.shift(); try { "function" == typeof a && p.debug("Executing request fulfilled " + a.name), r = a(r) } catch (e) { "function" == typeof l && p.debug("Executing request rejected " + l.name), l(e); break } } try { o = (!d.isNode && r.timeout ? c : n)(r) } catch (e) { return Promise.reject(e) } for (Array.prototype.unshift.apply(b, s); b.length;)o = o.then(b.shift(), b.shift()); return o } { p.debug("Interceptors are executed in asynchronous mode"); let t = [n, void 0]; for (Array.prototype.unshift.apply(t, i), Array.prototype.unshift.apply(t, v), t = (t = t.concat(s)).concat(b), o = Promise.resolve(r); t.length;)try { let e = t.shift(); var u = t.shift(); "function" == typeof (e = !d.isNode && r.timeout && e === n ? c : e) && p.debug("Executing request fulfilled " + e.name), "function" == typeof u && p.debug("Executing request rejected " + u.name), o = o.then(e, u) } catch (e) { p.error("request exception: " + e) } return o } function c(r) { try { var e = new Promise((e, t) => { setTimeout(() => { var e = { message: `timeout of ${r.timeout}ms exceeded.`, config: r }; t(e) }, r.timeout) }); return Promise.race([n(r), e]) } catch (e) { p.error(`Request Timeout exception: ${e}.`) } } }; return { request: r, interceptors: m, convertHeadersToLowerCase: r => Object.keys(r).reduce((e, t) => (e[t.toLowerCase()] = r[t], e), {}), convertHeadersToCamelCase: r => Object.keys(r).reduce((e, t) => { return e[t.split("-").map(e => e[0].toUpperCase() + e.slice(1)).join("-")] = r[t], e }, {}), modifyResponse: h, get: e => r("GET", e), post: e => r("POST", e), put: e => r("PUT", e), patch: e => r("PATCH", e), delete: e => r("DELETE", e), head: e => r("HEAD", e), options: e => r("OPTIONS", e) } } function MagicData(d, p) { let g = { fs: void 0, data: {} }; if (d.isNode) { g.fs = require("fs"); try { g.fs.accessSync("./magic.json", g.fs.constants.R_OK | g.fs.constants.W_OK) } catch (e) { g.fs.writeFileSync("./magic.json", "{}", { encoding: "utf8" }) } g.data = require("./magic.json") } const s = (e, t) => "object" != typeof t && e === t, a = e => "true" === e || "false" !== e && (void 0 === e ? null : e), l = (e, t, r, n) => { if (r) try { e = !0 === (e = "string" == typeof e ? JSON.parse(e) : e).magic_session ? e[r] : null } catch { e = null } if ("string" == typeof e && "null" !== e) try { e = JSON.parse(e) } catch { } return null == (e = !1 === n && e && !0 === e.magic_session ? null : e) && null != t && (e = t), e = a(e) }, f = t => { if ("string" != typeof t) return t instanceof Array || null == t || t != t || "boolean" == typeof t ? {} : t; { let e = {}; try { var r = typeof (e = JSON.parse(t)); ("object" != r || e instanceof Array || "bool" == r || null === e) && (e = {}) } catch { } return e } }, u = (e, t = null, r = "", n = !1, o = null) => { let i = ""; return i = o || d.isNode ? ((e, t = null, r = "", n = !1, o = null) => { o = o || g.data; return val = o && void 0 !== o[e] && null !== o[e] ? o[e] : r ? {} : null, val = l(val, t, r, n) })(e, t, r, n, o) : (d.isSurgeLike ? i = $persistentStore.read(e) : d.isQuanX && (i = $prefs.valueForKey(e)), l(i, t, r, n)), p.debug(`READ DATA [${e}]${r ? `[${r}]` : ""} <${typeof i}>` + "\n" + JSON.stringify(i)), i }, c = (e, t, r = "", n = null) => { if (void 0 === t || t != t) return !1; d.isNode || "boolean" != typeof t && "number" != typeof t || (t = String(t)); let o = ""; var i, s, a, l, u, c; if (n || d.isNode ? o = ([i, s, a = "", l = null] = [e, t, r, n], c = l || g.data, c = f(c), a ? ((u = f(c[i])).magic_session = !0, u[a] = s, c[i] = u) : c[i] = s, null !== l && (l = c), c) : r ? (d.isSurgeLike ? o = $persistentStore.read(e) ? $persistentStore.read(e) : o : d.isQuanX && (o = $prefs.valueForKey(e) ? $prefs.valueForKey(e) : o), (o = f(o)).magic_session = !0, o[r] = t) : o = t, o && "object" == typeof o && (o = JSON.stringify(o, null, 4)), p.debug(`WRITE DATA [${e}]${r ? `[${r}]` : ""} <${typeof t}>` + "\n" + JSON.stringify(t)), !n) { if (d.isSurgeLike) return $persistentStore.write(o, e); if (d.isQuanX) return $prefs.setValueForKey(o, e); if (d.isNode) try { g.fs.writeFileSync("./magic.json", o) } catch (e) { return p.error(e), !1 } } return !0 }; return { read: u, write: c, del: (e, t = "", r = null) => { let n = {}; if (r || d.isNode) n = (o = e, i = t, s = r || g.data, s = f(s), i ? (delete (obj = f(s[o]))[i], s[o] = obj) : delete s[o], s), r ? r = n : g.fs.writeFileSync("./magic.json", JSON.stringify(n, null, 4)); else if (t) { d.isSurgeLike ? n = $persistentStore.read(e) : d.isQuanX && (n = $prefs.valueForKey(e)), delete (n = f(n))[t]; i = JSON.stringify(n, null, 4); c(e, i) } else { if (d.isStorm) return $persistentStore.remove(e); if (d.isSurgeLike) return $persistentStore.write(null, e); if (d.isQuanX) return $prefs.removeValueForKey(e) } var o, i, s; p.debug(`DELETE KEY [${e}]` + (t ? `[${t}]` : "")) }, update: (e, t, r, n = s, o = null) => { var i; return t = a(t), !0 !== n(u(e, null, r, !1, o), t) && (i = c(e, t, r, o), e = u(e, null, r, !1, o), n === s && "object" == typeof e ? i : n(t, e)) }, allSessions: (e, t = null) => { let r = {}; t = u(e, null, null, !0, t); return !0 === (t = f(t)).magic_session && delete (r = { ...t }).magic_session, p.debug(`READ ALL SESSIONS [${e}] <${typeof r}>` + "\n" + JSON.stringify(r, null, 4)), r }, allSessionNames: (e, t = null) => { let r = []; t = u(e, null, null, !0, t), t = f(t); return r = !0 !== t.magic_session ? [] : Object.keys(t).filter(e => "magic_session" !== e), p.debug(`READ ALL SESSIONS [${e}] <${typeof r}>` + "\n" + JSON.stringify(r, null, 4)), r }, defaultValueComparator: s, convertToObject: f } } function MagicNotification(i, o, s, a) { let l = null, u = null, c = []; function d(e = i, t = "", r = "", n = "") { n = (t => { try { let e = {}; var r; return "string" == typeof t ? 0 < t.length && (o.isLoon ? e = { openUrl: t } : o.isQuanX ? e = { "open-url": t } : o.isSurge && (e = { url: t })) : "object" == typeof t && (o.isLoon ? (e.openUrl = t["open-url"] || "", e.mediaUrl = t["media-url"] || "") : o.isQuanX ? e = t["open-url"] || t["media-url"] ? t : {} : o.isSurge && (r = t["open-url"] || t.openUrl, e = r ? { url: r } : {})), e } catch (e) { s.error("通知选项转换失败" + e) } return t })(n), 1 === arguments.length && (e = i, t = "", r = arguments[0]), s.notify("\ntitle:" + e + "\nsubTitle:" + t + "\nbody:" + r + "\noptions:" + ("object" == typeof n ? JSON.stringify(n) : n)), o.isSurge ? $notification.post(e, t, r, n) : o.isLoon ? n ? $notification.post(e, t, r, n) : $notification.post(e, t, r) : o.isQuanX && $notify(e, t, r, n), l && u && p(e, t, r) } function p(e = i, t = "", r = "", n) { if (void 0 === a || void 0 === a.post) throw "Bark notification needs to import MagicHttp module."; e = { url: l, headers: { "content-type": "application/json; charset=utf-8" }, body: { title: e, body: t ? t + "\n" + r : r, device_key: u } }; a.post(e).catch(e => { s.error("Bark notify error: " + e) }) } return { post: d, debug: function (e = i, t = "", r = "", n = "") { "DEBUG" === s.getLevel() && (1 === arguments.length && (e = i, t = "", r = arguments[0]), this.post(e, t, r, n)) }, bark: p, setBark: e => { try { var t = e.replace(/\/+$/g, ""); l = /^https?:\/\/([^/]*)/.exec(t)[0] + "/push", u = /\/([^\/]+)\/?$/.exec(t)[1] } catch (e) { s.error(`Bark url error: ${e}.`) } }, appendNotifyInfo: function (e, t) { 1 == t ? c = e : c.push(e) }, prependNotifyInfo: function (e) { c.splice(0, 0, e) }, msg: function (e, t, r, n) { var o = {}; r && (o["open-url"] = r), n && (o["media-url"] = n), (t = t && 0 != t.length ? t : Array.isArray(c) ? c.join("\n") : c) && 0 < t.length && d(i, "", t, o) } } } function MagicUtils(n, u) { const e = (e, t = "yyyy-MM-dd hh:mm:ss") => { var r, n = { "M+": e.getMonth() + 1, "d+": e.getDate(), "h+": e.getHours(), "m+": e.getMinutes(), "s+": e.getSeconds(), "q+": Math.floor((e.getMonth() + 3) / 3), S: e.getMilliseconds() }; for (r in /(y+)/.test(t) && (t = t.replace(RegExp.$1, (e.getFullYear() + "").substr(4 - RegExp.$1.length))), n) new RegExp("(" + r + ")").test(t) && (t = t.replace(RegExp.$1, 1 === RegExp.$1.length ? n[r] : ("00" + n[r]).substr(("" + n[r]).length))); return t }; return { retry: (i, s = 5, a = 0, l = null) => (...e) => new Promise((r, n) => { function o(...t) { Promise.resolve().then(() => i.apply(this, t)).then(e => { "function" == typeof l ? Promise.resolve().then(() => l(e)).then(() => { r(e) }).catch(e => { 1 <= s ? 0 < a ? setTimeout(() => o.apply(this, t), a) : o.apply(this, t) : n(e), s-- }) : r(e) }).catch(e => { u.error(e), 1 <= s && 0 < a ? setTimeout(() => o.apply(this, t), a) : 1 <= s ? o.apply(this, t) : n(e), s-- }) } o.apply(this, e) }), formatTime: e, now: () => e(new Date, "yyyy-MM-dd hh:mm:ss"), today: () => e(new Date, "yyyy-MM-dd"), sleep: t => new Promise(e => setTimeout(e, t)), assert: (e, t = null) => { var r; n.isNode ? (r = require("assert"), t ? r(e, t) : r(e)) : !0 !== e && u.error("AssertionError: " + (t || "The expression evaluated to a falsy value.")) } } } function MagicQingLong(e, a, o) { let i = "", s = "", l = "", u = "", c = "", t = ""; const d = "magic.json", p = MagicHttp(e, o); async function r() { return l = l || a.read("magic_qlclient"), u = u || a.read("magic_qlsecrt"), s = s || a.read("magic_qlname"), c = c || a.read("magic_qlpwd"), i && l && u ? (o.info("Get token from QingLong Panel"), await p.get({ url: "/open/auth/token", headers: { "content-type": "application/json" }, params: { client_id: l, client_secret: u } }).then(e => { if (!(0 < Object.keys(e.body).length && e.body.data && e.body.data.token)) throw new Error("Get QingLong Panel token failed."); o.info("Successfully logged in to QingLong Panel"), t = e.body.data.token, a.write("magic_qltoken", t) }).catch(e => { o.error("Error logging in to QingLong Panel.\n" + (e.message || e)) })) : i && s && c && await p.post({ url: "/api/user/login", headers: { "content-type": "application/json" }, body: { username: s, password: c } }).then(e => { o.info("Successfully logged in to QingLong Panel"), t = e.body.data.token, a.write("magic_qltoken", t) }).catch(e => { o.error("Error logging in to QingLong Panel.\n" + (e.message || e)) }), t } async function g(e) { let t = []; return await p.post({ url: "/api/envs", headers: { "content-type": "application/json" }, body: e }).then(e => { 200 === e.body.code ? e.body.data.forEach(e => { o.debug(`QINGLONG ADD ENV ${e.name} <${typeof e.value}> (${e.id})` + "\n" + JSON.stringify(e)), t.push(e.id) }) : o.error("Error adding environments variable from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error adding environments variable from QingLong Panel.\n" + (e.message || e)) }), t } async function n(n = null, e = "", t) { let o = []; return await p.get({ url: "/api/envs", headers: { "content-type": "application/json" }, params: { searchValue: e } }).then(e => { if (200 !== e.body.code) throw new Error("Error reading environment variable from QingLong Panel.\n" + JSON.stringify(e)); e = e.body.data; if (n) { var t = []; for (const r of e) r.name === n && o.push(r); o = t } o = e }).catch(e => { throw new Error("Error reading environments variable from QingLong Panel.\n" + (e.message || e)) }), o } async function f(e, t = "") { let r = ""; return await p.get({ url: "/api/scripts/" + e, params: { path: t } }).then(e => { if (200 !== e.body.code) throw new Error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)); r = e.body.data }).catch(e => { throw new Error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), r } async function h(e, t = "", r = "") { let n = !1; return await p.put({ url: "/api/scripts", headers: { "content-type": "application/json" }, body: { filename: e, path: t, content: r } }).then(e => { 200 === e.body.code ? n = !0 : o.error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), n } return p.interceptors.request.use(function (e) { return i = i || a.read("magic_qlurl"), e.url.indexOf(i) < 0 && (e.url = "" + i + e.url), { ...e, timeout: 3e3 } }, void 0), p.interceptors.request.use(function (e) { return (l = l || a.read("magic_qlclient")) && (e.url = e.url.replace("/api/", "/open/")), e }, void 0, { runWhen: e => e.url.indexOf("api/user/login") < 0 && e.url.indexOf("open/auth/token") < 0 }), p.interceptors.request.use(async function (e) { return (t = t || a.read("magic_qltoken", "")) || await r(), e.headers.authorization = "Bearer " + t, e }, void 0, { runWhen: e => e.url.indexOf("api/user/login") < 0 && e.url.indexOf("open/auth/token") < 0 }), p.interceptors.request.use(function (e) { return e.params = { ...e.params, t: Date.now() }, e }, void 0, { runWhen: e => e.url.indexOf("open/auth/token") < 0 }), p.interceptors.request.use(function (e) { return i = i || a.read("magic_qlurl"), t = t || a.read("magic_qltoken"), o.debug("QingLong url: " + i + "\nQingLong token: " + t), e }, void 0), p.interceptors.response.use(void 0, async function (e) { try { var t = e.message || e.error || JSON.stringify(e); return (0 <= t.indexOf("NSURLErrorDomain") && 0 <= t.indexOf("-1012") || e.response && 401 === e.response.status) && e.config && !0 !== e.config.refreshToken ? (o.warning("QingLong Panel token has expired"), o.info("Refreshing the QingLong Panel token"), await r(), e.config.refreshToken = !0, o.info("Call the previous method again"), await p.request(e.config.method, e.config)) : Promise.reject(e) } catch (e) { return Promise.reject(e) } }), { url: i || a.read("magic_qlurl"), init: (e, t, r, n, o) => { i = e, l = t, u = r, s = n, c = o }, getToken: r, setEnv: async function (t, r, n = null) { if (i = i || a.read("magic_qlurl"), null === n) { var e = await g([{ name: t, value: r }]); if (e && 1 === e.length) return e[0] } else await p.put({ url: "/api/envs", headers: { "content-type": "application/json" }, body: { name: t, value: r, id: n } }).then(e => { if (200 === e.body.code) return o.debug(`QINGLONG UPDATE ENV ${t} <${typeof r}> (${n})` + "\n" + JSON.stringify(r)), !0; o.error("Error adding environment variable from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => (o.error("Error adding environment variable from QingLong Panel.\n" + (e.message || e)), !1)) }, setEnvs: g, getEnv: async function (e) { let t = null; for (const r of await n()) if (r.id === e) { t = r; break } return t }, getEnvs: n, delEnvs: async function (t) { return p.delete({ url: "/api/envs", headers: { accept: "application/json", "accept-language": "zh-CN,zh;q=0.9,en;q=0.8,en-GB;q=0.7,en-US;q=0.6", connection: "keep-alive", "content-type": "application/json;charset=UTF-8", "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36 Edg/102.0.1245.30" }, body: t }).then(e => 200 === e.body.code ? (o.debug("QINGLONG DELETE ENV IDS: " + t), !0) : (o.error("Error deleting environments variable from QingLong Panel.\n" + JSON.stringify(e)), !1)).catch(e => { o.error("Error deleting environments variable from QingLong Panel.\n" + (e.message || e)) }) }, disableEnvs: async function (t) { let r = !1; return await p.put({ url: "/api/envs/disable", headers: { accept: "application/json", "accept-Language": "zh-CN,zh;q=0.9,en;q=0.8,en-GB;q=0.7,en-US;q=0.6", connection: "keep-alive", "content-type": "application/json;charset=UTF-8", "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36 Edg/102.0.1245.30" }, body: t }).then(e => { 200 === e.body.code ? (o.debug("QINGLONG DISABLED ENV IDS: " + t), r = !0) : o.error("Error disabling environments variable from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error disabling environments variable from QingLong Panel.\n" + (e.message || e)) }), r }, enableEnvs: async function (t) { let r = !1; return await p.put({ url: "/api/envs/enable", headers: { accept: "application/json", "accept-language": "zh-CN,zh;q=0.9,en;q=0.8,en-GB;q=0.7,en-US;q=0.6", connection: "keep-alive", "content-type": "application/json;charset=UTF-8", "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36 Edg/102.0.1245.30" }, body: t }).then(e => { 200 === e.body.code ? (o.debug("QINGLONG ENABLED ENV IDS: " + t), r = !0) : o.error("Error enabling environments variable from Qilong panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error enabling environments variable from Qilong panel.\n" + (e.message || e)) }), r }, addScript: async function (e, t = "", r = "") { let n = !1; return await p.post({ url: "/api/scripts", headers: { "content-type": "application/json" }, body: { filename: e, path: t, content: r } }).then(e => { 200 === e.body.code ? n = !0 : o.error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), n }, getScript: f, editScript: h, delScript: async function (e, t = "") { let r = !1; return await p.delete({ url: "/api/scripts", headers: { "content-type": "application/json" }, body: { filename: e, path: t } }).then(e => { 200 === e.body.code ? r = !0 : o.error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), r }, write: async function (e, t, r = "") { var n = await f(d, ""), o = a.convertToObject(n), e = a.write(e, t, r, o), n = JSON.stringify(o, null, 4); return await h(d, "", n) && e }, read: async function (e, t, r = "", n = !1) { var o = await f(d, ""), o = a.convertToObject(o); return a.read(e, t, r, n, o) }, del: async function (e, t = "") { var r = await f(d, ""), n = a.convertToObject(r), e = a.del(e, t, n), r = JSON.stringify(n, null, 4), t = await h(d, "", r); return e && t }, update: async function (e, t, r, n = a.defaultValueComparator) { var o = await f(d, ""), i = a.convertToObject(o), e = a.update(e, t, r, n, i); let s = !1; return !0 === e && (o = JSON.stringify(i, null, 4), s = await h(d, "", o)), e && s }, batchWrite: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r); for (t of e) a.write(t[0], t[1], void 0 !== t[2] ? t[2] : "", n); return r = JSON.stringify(n, null, 4), h(d, "", r) }, batchRead: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r), o = []; for (t of e) { var i = a.read(t[0], t[1], void 0 !== t[2] ? t[2] : "", "boolean" == typeof t[3] && t[3], n); o.push(i) } return o }, batchUpdate: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r); for (t of e) a.update(t[0], t[1], void 0 !== t[2] ? t[2] : "", void 0 !== t[3] ? t.comparator : a.defaultValueComparator, n); return r = JSON.stringify(n, null, 4), h(d, "", r) }, batchDel: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r); for (t of e) a.del(t[0], void 0 !== t[1] ? t[1] : "", n); return r = JSON.stringify(n, null, 4), h(d, "", r) }, allSessions: async function (e) { var t = await f(d, ""), t = a.convertToObject(t); return a.allSessions(e, t) }, allSessionNames: async function (e) { var t = await f(d, ""), t = a.convertToObject(t); return a.allSessionNames(e, t) } } }
//---SyncByPyScript---MagicJS3-end

//---SyncByPyScript---w_md5-start
function hex_md5(r, n) { function a(r, n) { return r << n | r >>> 32 - n } function i(r, n) { var t = 2147483648 & r, e = 2147483648 & n, o = 1073741824 & r, u = 1073741824 & n, r = (1073741823 & r) + (1073741823 & n); return o & u ? 2147483648 ^ r ^ t ^ e : o | u ? 1073741824 & r ? 3221225472 ^ r ^ t ^ e : 1073741824 ^ r ^ t ^ e : r ^ t ^ e } function t(r, n, t, e, o, u, f) { return r = i(r, i(i(n & t | ~n & e, o), f)), i(a(r, u), n) } function e(r, n, t, e, o, u, f) { return r = i(r, i(i(n & e | t & ~e, o), f)), i(a(r, u), n) } function o(r, n, t, e, o, u, f) { return r = i(r, i(i(n ^ t ^ e, o), f)), i(a(r, u), n) } function u(r, n, t, e, o, u, f) { return r = i(r, i(i(t ^ (n | ~e), o), f)), i(a(r, u), n) } function f(r) { for (var n = "", t = "", e = 0; e <= 3; e++)n += (t = "0" + (r >>> 8 * e & 255).toString(16)).substr(t.length - 2, 2); return n } Array(); for (var h, c, d, C, m = function (r) { for (var n, t = r.length, e = 16 * (1 + ((e = t + 8) - e % 64) / 64), o = Array(e - 1), u = 0, f = 0; f < t;)u = f % 4 * 8, o[n = (f - f % 4) / 4] = o[n] | r.charCodeAt(f) << u, f++; return o[n = (f - f % 4) / 4] = o[n] | 128 << (u = f % 4 * 8), o[e - 2] = t << 3, o[e - 1] = t >>> 29, o }(r = function (r) { r = r.replace(/\r\n/g, "\n"); for (var n = "", t = 0; t < r.length; t++) { var e = r.charCodeAt(t); e < 128 ? n += String.fromCharCode(e) : n = 127 < e && e < 2048 ? (n += String.fromCharCode(e >> 6 | 192)) + String.fromCharCode(63 & e | 128) : (n = (n += String.fromCharCode(e >> 12 | 224)) + String.fromCharCode(e >> 6 & 63 | 128)) + String.fromCharCode(63 & e | 128) } return n }(r)), _ = 1732584193, g = 4023233417, p = 2562383102, x = 271733878, v = 0; v < m.length; v += 16)_ = t(h = _, c = g, d = p, C = x, m[v + 0], 7, 3614090360), x = t(x, _, g, p, m[v + 1], 12, 3905402710), p = t(p, x, _, g, m[v + 2], 17, 606105819), g = t(g, p, x, _, m[v + 3], 22, 3250441966), _ = t(_, g, p, x, m[v + 4], 7, 4118548399), x = t(x, _, g, p, m[v + 5], 12, 1200080426), p = t(p, x, _, g, m[v + 6], 17, 2821735955), g = t(g, p, x, _, m[v + 7], 22, 4249261313), _ = t(_, g, p, x, m[v + 8], 7, 1770035416), x = t(x, _, g, p, m[v + 9], 12, 2336552879), p = t(p, x, _, g, m[v + 10], 17, 4294925233), g = t(g, p, x, _, m[v + 11], 22, 2304563134), _ = t(_, g, p, x, m[v + 12], 7, 1804603682), x = t(x, _, g, p, m[v + 13], 12, 4254626195), p = t(p, x, _, g, m[v + 14], 17, 2792965006), _ = e(_, g = t(g, p, x, _, m[v + 15], 22, 1236535329), p, x, m[v + 1], 5, 4129170786), x = e(x, _, g, p, m[v + 6], 9, 3225465664), p = e(p, x, _, g, m[v + 11], 14, 643717713), g = e(g, p, x, _, m[v + 0], 20, 3921069994), _ = e(_, g, p, x, m[v + 5], 5, 3593408605), x = e(x, _, g, p, m[v + 10], 9, 38016083), p = e(p, x, _, g, m[v + 15], 14, 3634488961), g = e(g, p, x, _, m[v + 4], 20, 3889429448), _ = e(_, g, p, x, m[v + 9], 5, 568446438), x = e(x, _, g, p, m[v + 14], 9, 3275163606), p = e(p, x, _, g, m[v + 3], 14, 4107603335), g = e(g, p, x, _, m[v + 8], 20, 1163531501), _ = e(_, g, p, x, m[v + 13], 5, 2850285829), x = e(x, _, g, p, m[v + 2], 9, 4243563512), p = e(p, x, _, g, m[v + 7], 14, 1735328473), _ = o(_, g = e(g, p, x, _, m[v + 12], 20, 2368359562), p, x, m[v + 5], 4, 4294588738), x = o(x, _, g, p, m[v + 8], 11, 2272392833), p = o(p, x, _, g, m[v + 11], 16, 1839030562), g = o(g, p, x, _, m[v + 14], 23, 4259657740), _ = o(_, g, p, x, m[v + 1], 4, 2763975236), x = o(x, _, g, p, m[v + 4], 11, 1272893353), p = o(p, x, _, g, m[v + 7], 16, 4139469664), g = o(g, p, x, _, m[v + 10], 23, 3200236656), _ = o(_, g, p, x, m[v + 13], 4, 681279174), x = o(x, _, g, p, m[v + 0], 11, 3936430074), p = o(p, x, _, g, m[v + 3], 16, 3572445317), g = o(g, p, x, _, m[v + 6], 23, 76029189), _ = o(_, g, p, x, m[v + 9], 4, 3654602809), x = o(x, _, g, p, m[v + 12], 11, 3873151461), p = o(p, x, _, g, m[v + 15], 16, 530742520), _ = u(_, g = o(g, p, x, _, m[v + 2], 23, 3299628645), p, x, m[v + 0], 6, 4096336452), x = u(x, _, g, p, m[v + 7], 10, 1126891415), p = u(p, x, _, g, m[v + 14], 15, 2878612391), g = u(g, p, x, _, m[v + 5], 21, 4237533241), _ = u(_, g, p, x, m[v + 12], 6, 1700485571), x = u(x, _, g, p, m[v + 3], 10, 2399980690), p = u(p, x, _, g, m[v + 10], 15, 4293915773), g = u(g, p, x, _, m[v + 1], 21, 2240044497), _ = u(_, g, p, x, m[v + 8], 6, 1873313359), x = u(x, _, g, p, m[v + 15], 10, 4264355552), p = u(p, x, _, g, m[v + 6], 15, 2734768916), g = u(g, p, x, _, m[v + 13], 21, 1309151649), _ = u(_, g, p, x, m[v + 4], 6, 4149444226), x = u(x, _, g, p, m[v + 11], 10, 3174756917), p = u(p, x, _, g, m[v + 2], 15, 718787259), g = u(g, p, x, _, m[v + 9], 21, 3951481745), _ = i(_, h), g = i(g, c), p = i(p, d), x = i(x, C); return (32 == n ? f(_) + f(g) + f(p) + f(x) : f(g) + f(p)).toLowerCase() } function createWMd5() { var r = { hex_md5_16: function (r) { return hex_md5(r, 16) }, hex_md5_16Upper: function (r) { return hex_md5(r, 16).toUpperCase() }, hex_md5_32: function (r) { return hex_md5(r, 32) }, hex_md5_32Upper: function (r) { return hex_md5(r, 32).toUpperCase() } }; return r }
//---SyncByPyScript---w_md5-end